"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.prefetchIterable = void 0;
const assert_1 = __importDefault(require("assert"));
function* prefetchIterable(iterable, size) {
    (0, assert_1.default)(size >= 0);
    const iter = iterable[Symbol.iterator]();
    const buffer = [];
    for (let next = iter.next(); !next.done; next = iter.next()) {
        buffer.push(next.value);
        if (buffer.length >= size - 1) {
            const value = buffer[0];
            buffer.shift();
            yield value;
        }
    }
    yield* buffer;
}
exports.prefetchIterable = prefetchIterable;
//# sourceMappingURL=prefetch.js.map